class ExpectsMiddleware(object):
    def process_response(self, request, response, spider):
        expects = getattr(spider, 'expects', None)

        if expects is not None and not isinstance(response, expects):
            expected = ' or '.join(cls.__name__ for cls in expects) \
                if type(expects) is tuple else expects.__name__

            raise TypeError("%s: %s expected, got %s instead." % (
                spider.name, expected, response.__class__.__name__))

        return response
