from w3lib.url import file_uri_to_path
from scrapy.utils.decorators import defers

from .responses import responsetypes, TextResponse


class FileDownloadHandler(object):
    CHUNK_SIZE = 5000

    def __init__(self, settings):
        pass

    @defers
    def download_request(self, request, spider):
        filepath = file_uri_to_path(request.url)

        with open(filepath, 'rb') as fo:
            body_chunk = fo.read(self.CHUNK_SIZE)

        # Detect response type only from data, don't trust filename extension
        respcls = getattr(spider, 'expects', None) or \
                  responsetypes.from_args(body=body_chunk)

        stream = open(filepath) if issubclass(respcls, TextResponse) else \
                 open(filepath, 'rb')

        return respcls(url=request.url, stream=stream)
